diff --git a/linux-2.6.37.6-antonio/include/linux/stm_types.h b/linux-2.6.37.6-antonio/include/linux/stm_types.h
new file mode 100644
index 0000000..e661c49
--- /dev/null
+++ b/linux-2.6.37.6-antonio/include/linux/stm_types.h
@@ -0,0 +1,403 @@
+/*
+ * stm_types.h
+ *
+ *  Created on: Jan 5, 2012
+ *      Author: Antonio Barbalace <antoniob@vt.edu>
+ *
+ *  This work is a Linux kernel port of the TinySTM project.
+ */
+/*
+ * STM Types contains:
+ * configuration parameters (must be moved in KConfig)
+ * stm types definition (ok here)
+ */
+
+#ifndef STM_TYPES_H_
+#define STM_TYPES_H_
+
+/* Version string */
+# define STM_VERSION                    "1.0.0"
+/* Version number (times 100) */
+# define STM_VERSION_NB                 100
+
+//-----------------------------------------------------------------------------
+// CONFIGURATION STARTS HERE
+//-----------------------------------------------------------------------------
+
+/* ################################################################### *
+ * Contention managers
+ * ################################################################### */
+#define CM_SUICIDE                      0
+#define CM_DELAY                        1
+#define CM_BACKOFF                      2
+#define CM_MODULAR                      3
+
+#if defined(CONFIG_STM_CM_SUICIDE)
+# define CM                             CM_SUICIDE
+#elif defined(CONFIG_STM_CM_DELAY)
+# define CM                             CM_DELAY
+#else
+# define CM                             CM_SUICIDE
+#endif /* ! CM */
+
+//default WAIT_SPIN
+#undef WAIT_YIELD
+#undef WAIT_COND
+#if defined(CONFIG_STM_WAIT_YIELD)
+# define WAIT_YIELD
+#elif defined(CONFIG_STM_WAIT_COND)
+# define WAIT_COND
+#endif
+
+/* ################################################################### *
+ * DESIGNES
+ * ################################################################### */
+#define WRITE_BACK_ETL                  0
+#define WRITE_BACK_CTL                  1
+#define WRITE_THROUGH                   2
+
+#ifndef DESIGN
+# define DESIGN                         WRITE_BACK_ETL
+#endif /* ! DESIGN */
+
+// the followings cames from src/Makefile, lookup at the Makefile to write
+// the help for each KConfig configuration parameters (some are mod for our impl)
+//we also disable temporary IRREVOCABLE to speed the porting and testing (no test cases)
+//#define IRREVOCABLE_ENABLED
+#undef IRREVOCABLE_ENABLED
+#define INTERNAL_STATS
+#undef USE_BLOOM_FILTER
+#undef CONFLICT_TRACKING
+#undef READ_LOCKED_DATA
+
+#define CLOCK_IN_CACHE_LINE
+#undef NO_DUPLICATES_IN_RW_SETS
+//temporary disable for speed the porting TODO
+//#define EPOCH_GC
+#undef EPOCH_GC
+
+//TODO the following are very critical until not renamed
+//TODO (many other kernel components have the same name)
+//#undef DEBUG
+//#define DEBUG
+//#undef DEBUG2
+//#define DEBUG2
+
+//#define EXPLICIT_TX_PARAMETER
+
+#ifndef RW_SET_SIZE
+# define RW_SET_SIZE                    4096                /* Initial size of read/write sets */
+#endif /* ! RW_SET_SIZE */
+
+#ifndef LOCK_ARRAY_LOG_SIZE
+# define LOCK_ARRAY_LOG_SIZE            20                  /* Size of lock array: 2^20 = 1M */
+#endif /* LOCK_ARRAY_LOG_SIZE */
+
+#ifndef LOCK_SHIFT_EXTRA
+# define LOCK_SHIFT_EXTRA               2                   /* 2 extra shift */
+#endif /* LOCK_SHIFT_EXTRA */
+
+//the followings are too related to the particular choice of
+//the conflict manager so they remain in the ipc/stm.h
+//# DEFINES += -DMIN_BACKOFF=0x04UL
+//# DEFINES += -DMAX_BACKOFF=0x80000000UL
+//# DEFINES += -DVR_THRESHOLD_DEFAULT=3
+
+
+//-----------------------------------------------------------------------------
+// STM TYPES START HERE
+//-----------------------------------------------------------------------------
+
+/*
+ * The library does not require to pass the current transaction as a
+ * parameter to the functions (the current transaction is stored in a
+ * thread-local variable).  One can, however, compile the library with
+ * explicit transaction parameters.  This is useful, for instance, for
+ * performance on architectures that do not support TLS or for easier
+ * compiler integration.
+ */
+# ifdef EXPLICIT_TX_PARAMETER
+struct stm_tx;
+#  define TXTYPE                        struct stm_tx *
+#  define TXPARAM                       struct stm_tx *tx
+#  define TXPARAMS                      struct stm_tx *tx,
+#  define TXARG                         (struct stm_tx *)tx
+#  define TXARGS                        (struct stm_tx *)tx,
+struct stm_tx *stm_current_tx();
+# else /* ! EXPLICIT_TX_PARAMETER */
+#  define TXTYPE                        void
+#  define TXPARAM                       /* Nothing */
+#  define TXPARAMS                      /* Nothing */
+#  define TXARG                         /* Nothing */
+#  define TXARGS                        /* Nothing */
+#endif /* ! EXPLICIT_TX_PARAMETER */
+
+#ifdef EXPLICIT_TX_PARAMETER
+# define TX_RETURN                      return tx
+# define TX_GET                         /* Nothing */
+#else /* ! EXPLICIT_TX_PARAMETER */
+# define TX_RETURN                      /* Nothing */
+# define TX_GET                         stm_tx_t *tx = stm_get_tx()
+#endif /* ! EXPLICIT_TX_PARAMETER */
+
+/**
+ * Size of a word (accessible atomically) on the target architecture.
+ * The library supports 32-bit and 64-bit architectures.
+ */
+// the following is defined in <linux/types.h>
+typedef uintptr_t stm_word_t;
+
+/**
+ * Transaction attributes specified by the application.
+ */
+typedef struct stm_tx_attr {
+  /**
+   * Application-specific identifier for the transaction.  Typically,
+   * each transactional construct (atomic block) should have a different
+   * identifier.  This identifier can be used by the infrastructure for
+   * improving performance, for instance by not scheduling together
+   * atomic blocks that have conflicted often in the past.
+   */
+  int id;
+  /**
+   * Indicates whether the transaction is read-only.  This information
+   * is used as a hint.  If a read-only transaction performs a write, it
+   * is aborted and restarted in read-write mode.  In that case, the
+   * value of the read-only flag is changed to false.  If no attributes
+   * are specified when starting a transaction, it is assumed to be
+   * read-write.
+   */
+  unsigned int read_only : 1;
+  /**
+   * Indicates that the transaction should not retry execution using
+   * sigsetjmp() after abort.  If no attributes are specified when
+   * starting a transaction, the default behavior is to retry.
+   */
+  unsigned int no_retry : 1;
+} stm_tx_attr_t;
+
+typedef struct r_entry {                /* Read set entry */
+  stm_word_t version;                   /* Version read */
+  volatile stm_word_t *lock;            /* Pointer to lock (for fast access) */
+} r_entry_t;
+
+typedef struct r_set {                  /* Read set */
+  r_entry_t *entries;                   /* Array of entries */
+  int nb_entries;                       /* Number of entries */
+  int size;                             /* Size of array */
+} r_set_t;
+
+typedef struct w_entry {                /* Write set entry */
+  union {                               /* For padding... */
+    struct {
+      volatile stm_word_t *addr;        /* Address written */
+      stm_word_t value;                 /* New (write-back) or old (write-through) value */
+      stm_word_t mask;                  /* Write mask */
+      stm_word_t version;               /* Version overwritten */
+      volatile stm_word_t *lock;        /* Pointer to lock (for fast access) */
+#if CM == CM_MODULAR || (defined(CONFLICT_TRACKING) && DESIGN != WRITE_THROUGH)
+      struct stm_tx *tx;                /* Transaction owning the write set */
+#endif /* CM == CM_MODULAR || (defined(CONFLICT_TRACKING) && DESIGN != WRITE_THROUGH) */
+#if DESIGN == WRITE_BACK_ETL
+      struct w_entry *next;             /* Next address covered by same lock (if any) */
+#else /* DESIGN != WRITE_BACK_ETL */
+      int no_drop;                      /* Should we drop lock upon abort? */
+#endif /* DESIGN != WRITE_BACK_ETL */
+    };
+    stm_word_t padding[8];              /* Padding (multiple of a cache line) */
+  };
+} w_entry_t;
+
+typedef struct w_set {                  /* Write set */
+  w_entry_t *entries;                   /* Array of entries */
+  int nb_entries;                       /* Number of entries */
+  int size;                             /* Size of array */
+#if DESIGN == WRITE_BACK_ETL
+  int has_writes;                       /* Has the write set any real write (vs. visible reads) */
+#elif DESIGN == WRITE_BACK_CTL
+  int nb_acquired;                      /* Number of locks acquired */
+# ifdef USE_BLOOM_FILTER
+  stm_word_t bloom;                     /* Same Bloom filter as in TL2 */
+# endif /* USE_BLOOM_FILTER */
+#endif /* DESIGN == WRITE_BACK_CTL */
+} w_set_t;
+
+typedef struct cb_entry {               /* Callback entry */
+  void (*f)(TXPARAMS void *);           /* Function */
+  void *arg;                            /* Argument to be passed to function */
+} cb_entry_t;
+
+#ifndef MAX_SPECIFIC
+# define MAX_SPECIFIC                   64
+#endif /* MAX_SPECIFIC */
+
+/* ################################################################### *
+ * TYPES
+ * ################################################################### */
+
+typedef struct mod_stats_data {         /* Transaction statistics */
+  unsigned long commits;                /* Total number of commits (cumulative) */
+  unsigned long retries;                /* Number of consecutive aborts of current transaction (retries) */
+  unsigned long retries_min;            /* Minimum number of consecutive aborts */
+  unsigned long retries_max;            /* Maximum number of consecutive aborts */
+  unsigned long retries_acc;            /* Total number of aborts (cumulative) */
+  unsigned long retries_cnt;            /* Number of samples for cumulative aborts */
+} mod_stats_data_t;
+
+typedef struct stm_tx {                 /* Transaction descriptor */
+//  sigjmp_buf env;                       /* Environment for setjmp/longjmp (must be first field!) */
+	uintptr_t snapshot;						// snapshot id of the transaction
+
+  stm_tx_attr_t attr;                  /* Transaction attributes (user-specified) */
+  volatile stm_word_t status;           /* Transaction status */
+  stm_word_t start;                     /* Start timestamp */
+  stm_word_t end;                       /* End timestamp (validity range) */
+  r_set_t r_set;                        /* Read set */
+  w_set_t w_set;                        /* Write set */
+  unsigned int ro:1;                    /* Is this execution read-only? */
+  unsigned int can_extend:1;            /* Can this transaction be extended? */
+#ifdef IRREVOCABLE_ENABLED
+  unsigned int irrevocable:4;           /* Is this execution irrevocable? */
+#endif /* IRREVOCABLE_ENABLED */
+  int nesting;                          /* Nesting level */
+#if CM == CM_MODULAR
+  stm_word_t timestamp;                 /* Timestamp (not changed upon restart) */
+#endif /* CM == CM_MODULAR */
+  void *data[MAX_SPECIFIC];             /* Transaction-specific data (fixed-size array for better speed) */
+  struct stm_tx *next;                  /* For keeping track of all transactional threads */
+// TODO
+//#ifdef CONFLICT_TRACKING
+//  pthread_t thread_id;                  /* Thread identifier (immutable) */
+//#endif /* CONFLICT_TRACKING */
+#if CM == CM_DELAY || CM == CM_MODULAR
+  volatile stm_word_t *c_lock;          /* Pointer to contented lock (cause of abort) */
+#endif /* CM == CM_DELAY || CM == CM_MODULAR */
+#if CM == CM_BACKOFF
+  unsigned long backoff;                /* Maximum backoff duration */
+  unsigned long seed;                   /* RNG seed */
+#endif /* CM == CM_BACKOFF */
+#if CM == CM_MODULAR
+  int visible_reads;                    /* Should we use visible reads? */
+#endif /* CM == CM_MODULAR */
+#ifdef CONFIG_STM_PREEMPT_BONUS
+  int bonus;
+#endif /* STM_PREEMPT_AVOIDANCE */
+#if CM == CM_MODULAR || defined(INTERNAL_STATS)
+  unsigned long retries;                /* Number of consecutive aborts (retries) */
+#endif /* CM == CM_MODULAR || defined(INTERNAL_STATS) */
+#ifdef INTERNAL_STATS
+  unsigned long aborts;                 /* Total number of aborts (cumulative) */
+  unsigned long aborts_1;               /* Total number of transactions that abort once or more (cumulative) */
+  unsigned long aborts_2;               /* Total number of transactions that abort twice or more (cumulative) */
+  unsigned long aborts_ro;              /* Aborts due to wrong read-only specification (cumulative) */
+  unsigned long aborts_locked_read;     /* Aborts due to trying to read when locked (cumulative) */
+  unsigned long aborts_locked_write;    /* Aborts due to trying to write when locked (cumulative) */
+  unsigned long aborts_validate_read;   /* Aborts due to failed validation upon read (cumulative) */
+  unsigned long aborts_validate_write;  /* Aborts due to failed validation upon write (cumulative) */
+  unsigned long aborts_validate_commit; /* Aborts due to failed validation upon commit (cumulative) */
+  unsigned long aborts_invalid_memory;  /* Aborts due to invalid memory access (cumulative) */
+# if CM == CM_MODULAR
+  unsigned long aborts_killed;          /* Aborts due to being killed (cumulative) */
+# endif /* CM == CM_MODULAR */
+# ifdef READ_LOCKED_DATA
+  unsigned long locked_reads_ok;        /* Successful reads of previous value */
+  unsigned long locked_reads_failed;    /* Failed reads of previous value */
+# endif /* READ_LOCKED_DATA */
+  unsigned long max_retries;            /* Maximum number of consecutive aborts (retries) */
+#endif /* INTERNAL_STATS */
+  /* local stats*/
+  mod_stats_data_t mod_stats;
+
+  struct {
+  	void * addr;
+  	int size;
+  } stack;
+
+} stm_tx_t;
+
+/**
+ * Reason for aborting (returned by sigsetjmp() upon transaction
+ * restart).
+ */
+enum {
+  /**
+   * Abort due to explicit call from the programmer (no retry).
+   */
+  STM_ABORT_EXPLICIT = (1 << 4),
+  /**
+   * Implicit abort (high order bits indicate more detailed reason).
+   */
+  STM_ABORT_IMPLICIT = (1 << 5),
+  /**
+   * Abort upon reading a memory location being read by another
+   * transaction.
+   */
+  STM_ABORT_RR_CONFLICT = (1 << 5) | (0x01 << 8),
+  /**
+   * Abort upon writing a memory location being read by another
+   * transaction.
+   */
+  STM_ABORT_RW_CONFLICT = (1 << 5) | (0x02 << 8),
+  /**
+   * Abort upon reading a memory location being written by another
+   * transaction.
+   */
+  STM_ABORT_WR_CONFLICT = (1 << 5) | (0x03 << 8),
+  /**
+   * Abort upon writing a memory location being written by another
+   * transaction.
+   */
+  STM_ABORT_WW_CONFLICT = (1 << 5) | (0x04 << 8),
+  /**
+   * Abort upon read due to failed validation.
+   */
+  STM_ABORT_VAL_READ = (1 << 5) | (0x05 << 8),
+  /**
+   * Abort upon write due to failed validation.
+   */
+  STM_ABORT_VAL_WRITE = (1 << 5) | (0x06 << 8),
+  /**
+   * Abort upon commit due to failed validation.
+   */
+  STM_ABORT_VALIDATE = (1 << 5) | (0x07 << 8),
+  /**
+   * Abort upon write from a transaction declared as read-only.
+   */
+  STM_ABORT_RO_WRITE = (1 << 5) | (0x08 << 8),
+  /**
+   * Abort upon deferring to an irrevocable transaction.
+   */
+  STM_ABORT_IRREVOCABLE = (1 << 5) | (0x09 << 8),
+  /**
+   * Abort due to being killed by another transaction.
+   */
+  STM_ABORT_KILLED = (1 << 5) | (0x0A << 8),
+  /**
+   * Abort due to receiving a signal.
+   */
+  STM_ABORT_SIGNAL = (1 << 5) | (0x0B << 8),
+  /**
+   * Abort due to other reasons (internal to the protocol).
+   */
+  STM_ABORT_OTHER = (1 << 5) | (0x0F << 8)
+};
+
+
+/**
+ * Initialize a transactional thread.  This function must be called once
+ * from each thread that performs transactional operations, before the
+ * thread calls any other functions of the library.
+ */
+//TXTYPE stm_init_thread( void);
+stm_tx_t * stm_init_thread( void);
+
+/**
+ * Clean up a transactional thread.  This function must be called once
+ * from each thread that performs transactional operations, upon exit.
+ */
+//void stm_exit_thread(TXPARAM);
+void stm_exit_thread(stm_tx_t * a);
+
+
+
+#endif /* STM_TYPES_H_ */
diff --git a/linux-2.6.37.6-antonio/include/linux/syscalls.h b/linux-2.6.37.6-antonio/include/linux/syscalls.h
index cacc27a..b50ee66 100644
--- a/linux-2.6.37.6-antonio/include/linux/syscalls.h
+++ b/linux-2.6.37.6-antonio/include/linux/syscalls.h
@@ -833,4 +833,6 @@ asmlinkage long sys_mmap_pgoff(unsigned long addr, unsigned long len,
 			unsigned long fd, unsigned long pgoff);
 asmlinkage long sys_old_mmap(struct mmap_arg_struct __user *arg);
 
+asmlinkage long sys_checkpoint(int key, int msgflg);
+
 #endif
diff --git a/linux-2.6.37.6-antonio/ipc/Makefile b/linux-2.6.37.6-antonio/ipc/Makefile
index 9075e17..bd3c6f5 100644
--- a/linux-2.6.37.6-antonio/ipc/Makefile
+++ b/linux-2.6.37.6-antonio/ipc/Makefile
@@ -8,5 +8,5 @@ obj-$(CONFIG_SYSVIPC_SYSCTL) += ipc_sysctl.o
 obj_mq-$(CONFIG_COMPAT) += compat_mq.o
 obj-$(CONFIG_POSIX_MQUEUE) += mqueue.o msgutil.o $(obj_mq-y)
 obj-$(CONFIG_IPC_NS) += namespace.o
-obj-$(CONFIG_POSIX_MQUEUE_SYSCTL) += mq_sysctl.o
+obj-$(CONFIG_POSIX_MQUEUE_SYSCTL) += mq_sysctl.o snapshot.o stm.o
 
